# VMS Makefile for Zip, ZipNote, ZipCloak and ZipSplit

#
#  Modified to support both AXP and VAX by Hunter Goatley, 10-SEP-1993 06:43
#
#  To build under OpenVMS AXP, you must define the macro __ALPHA__:
#
#	$ MMS/MACRO=(__ALPHA__=1)
#
.IFDEF EXE			!If EXE and OBJ aren't defined, define them
.ELSE
EXE = .EXE
OBJ = .OBJ
.ENDIF

CFLAGS = /NOLIST/OBJECT=$(MMS$TARGET)

OPTFILE = vaxcrtl.opt

.IFDEF __ALPHA__		!Under OpenVMS AXP, we must use /STAN=VAXC
CFLG_ARCH = /STANDARD=VAXC/ANSI_ALIAS
OPTFILE_LIST =
OPTIONS =
.ELSE
.IFDEF __DECC_VAX__		!Under DECC VAX, we must use /STAN=VAXC
CFLG_ARCH = /STANDARD=VAXC/ANSI_ALIAS
OPTFILE_LIST =
OPTIONS =
.ELSE
CFLG_ARCH =
OPTFILE_LIST = ,$(OPTFILE)
OPTIONS = $(OPTFILE_LIST)/OPT
.ENDIF
.ENDIF

.IFDEF DEBUG
LDEB = /DEBUG
CDEB = /DEBUG/NOOPT
.ELSE
LDEB = /NOTRACE
CDEB =
.ENDIF

LINK = $(LINK)$(LDEB)

OBJZ =	zip$(OBJ),zipfile$(OBJ),zipup$(OBJ),fileio$(OBJ),util$(OBJ),-
	globals$(OBJ),crypt$(OBJ),vms$(OBJ),VMSmunch$(OBJ)
OBJI =	deflate$(OBJ),trees$(OBJ),bits$(OBJ)
OBJU =	zipfile$(OBJ)_,zipup$(OBJ)_,fileio$(OBJ)_,globals$(OBJ),-
	util$(OBJ)_,vms_$(OBJ),VMSmunch$(OBJ)
OBJN =	zipnote$(OBJ),$(OBJU)
OBJS =	zipsplit$(OBJ),$(OBJU)
OBJC =	zipcloak$(OBJ),$(OBJU),crypt$(OBJ)_

!
!  Define our new suffixes list
!
.SUFFIXES :
.SUFFIXES :	$(EXE) $(OBJ)_ $(OBJ) .C

.c$(OBJ) :
	$(CC) $(CFLG_ARCH) $(CFLAGS) $(CDEB) $(MMS$SOURCE)

!
!  .OBJ_ files are used by the Zip utilities (ZipNote, ZipCloak, ZipSplit)
!
.c$(OBJ)_ :
	$(CC) $(CFLG_ARCH) $(CFLAGS) $(CDEB) /DEFINE=("UTIL") $(MMS$SOURCE)

# rules for zip, zipnote, zipsplit, and zip.doc.

default :	zip$(EXE),zipnote$(EXE),zipsplit$(EXE),zipcloak$(EXE)
 @ !

zipfile$(OBJ)_ :	zipfile.c
zipup$(OBJ)_   :	zipup.c,revision.h
fileio$(OBJ)_  :	fileio.c
util$(OBJ)_    :	util.c
crypt$(OBJ)_   :	crypt.c
vms$(OBJ)_     :	vms.c

$(OBJZ) : zip.h,ziperr.h,tailor.h
$(OBJI) : zip.h,ziperr.h,tailor.h
$(OBJN) : zip.h,ziperr.h,tailor.h
$(OBJS) : zip.h,ziperr.h,tailor.h

zip$(OBJ),zipcloak$(OBJ),zipup$(OBJ),zipnote$(OBJ),zipsplit$(OBJ) : revision.h

zipfile$(OBJ), fileio$(OBJ), VMSmunch$(OBJ) : VMSmunch.h

zip$(EXE) : $(OBJZ),$(OBJI)$(OPTFILE_LIST)
	$(LINK)/exe=zip$(EXE) $(OBJZ),$(OBJI)$(OPTIONS)

zipnote$(EXE) : $(OBJN)$(OPTFILE_LIST)
	$(LINK)/exe=zipnote$(EXE) $(OBJN)$(OPTIONS)

zipsplit$(EXE) : $(OBJS)$(OPTFILE_LIST)
	$(LINK)/exe=zipsplit$(EXE) $(OBJS)$(OPTIONS)

zipcloak$(EXE) : $(OBJC)$(OPTFILE_LIST)
	$(LINK)/exe=zipcloak$(EXE) $(OBJC)$(OPTIONS)

$(OPTFILE) :
	@ open/write tmp $(OPTFILE)
	@ write tmp "SYS$SHARE:VAXCRTL.EXE/SHARE"
	@ close tmp

clean.com :
	@ open/write tmp $(MMS$TARGET)
	@ write tmp "$!"
	@ write tmp "$!	Clean.com --	procedure to delete files. It always returns success"
	@ write tmp "$!			status despite any error or warnings. Also it extracts"
	@ write tmp "$!			filename from MMS ""module=file"" format."
	@ write tmp "$!"
	@ write tmp "$ on control_y then goto ctly"
	@ write tmp "$ if p1.eqs."""" then exit 1"
	@ write tmp "$ i = -1"
	@ write tmp "$scan_list:"
	@ write tmp "$	i = i+1"
	@ write tmp "$	item = f$elem(i,"","",p1)"
	@ write tmp "$	if item.eqs."""" then goto scan_list"
	@ write tmp "$	if item.eqs."","" then goto done		! End of list"
	@ write tmp "$	item = f$edit(item,""trim"")		! Clean of blanks"
	@ write tmp "$	wild = f$elem(1,""="",item)"
	@ write tmp "$	show sym wild"
	@ write tmp "$	if wild.eqs.""="" then wild = f$elem(0,""="",item)"
	@ write tmp "$	vers = f$parse(wild,,,""version"",""syntax_only"")"
	@ write tmp "$	if vers.eqs."";"" then wild = wild - "";"" + "";*"""
	@ write tmp "$scan:"
	@ write tmp "$		f = f$search(wild)"
	@ write tmp "$		if f.eqs."""" then goto scan_list"
	@ write tmp "$		on error then goto err"
	@ write tmp "$		on warning then goto warn"
	@ write tmp "$		delete/log 'f'"
	@ write tmp "$warn:"
	@ write tmp "$err:"
	@ write tmp "$		goto scan"
	@ write tmp "$done:"
	@ write tmp "$ctly:"
	@ write tmp "$	exit 1"
	@ close tmp

clean : clean.com
	@clean "$(OBJZ)"
	@clean "$(OBJI)"
	@clean "$(OBJU)"
	@clean "$(OBJN)"
	@clean "$(OBJS)"
	@clean "$(OBJC)"
	@clean $(OPTFILE)
	- delete zip$(EXE);*,zipnote$(EXE);*,zipsplit$(EXE);*,zipcloak$(EXE);*
	- delete clean.com;*
